<%
db_name = "webhost_clients"
db_host = "localhost"

db_user = Request.Cookies("db_user")
db_pass = Request.Cookies("db_pass")

function param(Name)
         param = ""  
         
         if Request.Cookies(Name) <> "" then
            param = Request.Cookies(Name)
         end if                
         
         if Request.Form(Name) <> "" then
            param = Request.Form(Name)
         end if

         if Request.QueryString(Name) <> "" then
            param = Request.QueryString(Name)
         end if                           
end function

logged_in = false

set Connection = server.CreateObject("ADODB.Connection")
         
on error resume next

Connection.open db_name, db_user, db_pass

if Err.number = 0 and db_name <> "" and db_pass <> "" then
   logged_in = true
       
   save = param("save")
   client_id = param("client_id") 
   site_id = param("site_id")
     
   client_name = param("client_name")
   client_email = param("client_email")
   client_phone_number = param("client_phone_number")
      
   if client_id > 0 and save = "0" then
      update = "update clients set " & _
               "name = '" & client_name & "', " & _
               "email = '" & client_email & "', " & _
               "phone_number = '" & client_phone_number & "' " & _
               "where id = " & client_id
              
      Connection.Execute(update)
   end if
      
   if client_id = "0" and site_id = "0" and save = "0" then        
      insert = "insert into clients (name, email, phone_number) values (" & _
               "'" & client_name & "', " & _
               "'" & client_email & "', " & _
               "'" & client_phone_number & "')"
              
      Connection.Execute(insert)          
              
      mysql_insert_id = Connection.Execute("select last_insert_id() as id")
      client_id = mysql_insert_id("id")
   end if
    
   site_name = param("site_name")
   site_user = param("site_user")
   site_creation_day = param("site_creation_day")
   site_creation_month = param("site_creation_month")
   site_creation_year = param("site_creation_year")
   site_creation_date = site_creation_year & "-" & _
                        site_creation_month & "-" & _
                        site_creation_day
   site_mothly_fee = 0.0
   site_annual_fee = 0.0
   fee = param("fee")
   
   if fee = "monthly" then
      site_mothly_fee = param("site_fee")
   else
      site_annual_fee = param("site_fee")
   end if
   
   name_vendor_id = param("name_vendor_id")
   processor_id = param("processor_id")
  
   if site_id > 0 and save = "0" then
      update = "update sites set " & _
               "name = '" & site_name & "', " & _
               "user = '" & site_user & "', " & _
               "creation_date = '" & site_creation_date & "', " & _
               "monthly_fee = " & site_mothly_fee & ", " & _
               "annual_fee = " & site_annual_fee & ", " & _
               "client_id = " & client_id & ", " & _
               "name_vendor_id = " & name_vendor_id & ", " & _
               "processor_id = " & processor_id & _
               " where id = " & site_id
           
      Connection.Execute(update)
   end if
  
   if site_id < 0 then
      deleted_domain = param("deleted_domain_" & (-site_id))
    
      deleted_client_id = Connection.Execute("select client_id from sites where id = " & (-site_id) & _
                                             " and name = '" & deleted_domain & "'")
                                    
      if deleted_client_id.EOF = true then
         number_of_sites = Connection.Execute("select count(id) as coun from sites where client_id = " & deleted_client_id("client_id"))
              
         if number_of_sites("coun") = 1 then
            Connection.Execute("delete from clients where id = " & deleted_client_id("client_id"))
         end if
       
        Connection.Execute("delete from sites where id = " & (-site_id))
      end if
   end if
    
   if site_id = "0" and save = "0" then
      insert = "insert into sites " & _
               "(name, user, creation_date, monthly_fee, annual_fee, client_id, name_vendor_id, processor_id) "  & _
               "values (" & _
               "'" & site_name & "', " & _
               "'" & site_user & "', " & _
               "'" & site_creation_date & "', " & _
               site_mothly_fee & ", " & _
               site_annual_fee & ", " & _
               client_id & ", " & _
               name_vendor_id & ", " & _
               processor_id & ")"                  
    
      Connection.Execute(insert)
   end if
        
   selected_month = param("month")   
   if selected_month = "" then
      selected_month = month(date)
   end if         
    
   month_filter1 = ""
   month_filter2 = ""
   month_filter3 = " * 12"
   if selected_month <> 0 then
      month_filter1 = " and MONTH(creation_date) = " & selected_month
      month_filter2 = " where MONTH(creation_date) = " & selected_month
      month_filter3 = ""
   end if
  
   select_query = "select clients.id as client_id, clients.name as client_name, email, phone_number, " & _
                  "sites.id as site_id, sites.name as site_name, user, monthly_fee, annual_fee, name_vendor_id, processor_id, " & _
                  "creation_date, DAYOFMONTH(creation_date) as creation_day, MONTH(creation_date) as creation_month, YEAR(creation_date) as creation_year, " & _
                  "processors.name as processor_name, name_vendors.name as name_vendor_name " & _
                  "from (clients left outer join sites on clients.id = sites.client_id), processors, name_vendors " & _
                  "where sites.processor_id = processors.id and sites.name_vendor_id = name_vendors.id " & _
                  month_filter1 & _
                  " order by clients.name, sites.name"
   set client_sites  = Connection.Execute(select_query)    
      
   select_query = "select id, name, email, phone_number from clients order by name"
   set clients = Connection.Execute(select_query)
  
   select_query = "select name, id from processors"
   set processors = Connection.Execute(select_query)
  
   select_query = "select name, id from name_vendors"
   set name_vendors = Connection.Execute(select_query)
  
   select_query = "select ifnull(sum(monthly_fee), 0.00)" & month_filter3 & " + 0.00 as sum from sites"
   set monthly_fee = Connection.Execute(select_query)   
  
   select_query = "select ifnull(sum(annual_fee), 0.00) as sum from sites " & month_filter2
   set annual_fee = Connection.Execute(select_query)
end if
%>

<html>
<head>
<title>web hosting client manager</title>

<style>
a {color:000000;}

.headings {font-family:'arial, sans-serif, verdana'; font-weight:bold; color:555555;}
</style>

<% if logged_in = true then %>
<script>
function SelectClient(client_id)
         {
         if(document.whcm.site_id.value == '')
            document.whcm.site_id.value = '0';     
         
         switch(client_id)
               {               
               <% while clients.EOF = false %>
               case '<%= clients("id") %>':
                    document.whcm.client_name.value = '<%= clients("name") %>';
                    document.whcm.client_email.value = '<%= clients("email") %>';
                    document.whcm.client_phone_number.value = '<%= clients("phone_number") %>';                  
                    break;
               <% 
                  clients.MoveNext
                  wend 
               %>
               default:               
                    document.whcm.client_name.value = '';
                    document.whcm.client_email.value = '';
                    document.whcm.client_phone_number.value = '';
               }
         }

function SelectValue(SelectName, Value)
         {
         eval('SelectObject = document.whcm.' + SelectName + ';');
         for(index = 0; index < SelectObject.length; index++)
            {
            if(SelectObject[index].value = Value)
               SelectObject.selectedIndex = index;
            }
         }
</script>
<% end if 'if logged_in = true %>
</head>

<body bgcolor="eecc99" <% if save = "0" then %>onload="document.whcm.submit();"<% end if %>>
<a name="edit"></a>
<form name="whcm" method="post">
<input type="hidden" name="save" />
<input type="hidden" name="site_id" value="0" />
<table align="center" bgcolor="eeeeee">

<% if logged_in = true then %>

<tr>
<td>
     <table width="100%" cellpadding="5" bgcolor="eecc99">
     
     <tr>
     <td valign="top">
         <table>
         <tr>
         <td></td>
         <td>
         <select name="client_id"
                 onchange="SelectClient(document.whcm.client_id[document.whcm.client_id.selectedIndex].value);">
         <option value="0">New Client</option>
         <% 
         clients.MoveFirst
         while clients.EOF = false 
         %>
         <option value="<%= clients("id") %>"><%= clients("name") %></option>
         <% 
         clients.MoveNext
         wend 
         %>
         </select>
         </td>
         </tr>
         
         <tr>
         <td>Client Name</td>
         <td><input type="text" name="client_name" /></td>
         </tr>
         
         <tr>
         <td>Client Email</td>
         <td><input type="text" name="client_email" /></td>
         </tr>
         
         <tr>
         <td>Client Phone Number</td>
         <td><input type="text" name="client_phone_number" /></td>
         </tr>
         </table>
     </td>
     <td align="right" valign="top">
         <table>
         <tr>
         <td>Site Name</td>
         <td><input type="text" name="site_name" /></td>
         </tr>
         
         <tr>
         <td>Name Vendor</td>
         <td>
         <select name="name_vendor_id">
         <%
         while name_vendors.EOF = false 
         %>
         <option value="<%= name_vendors("id") %>"><%= name_vendors("name") %></option>
         <% 
         name_vendors.MoveNext
         wend 
         %>
         </select>
         </td>
         </tr>
         
         <tr>
         <td>Site User</td>
         <td><input type="text" name="site_user" /></td>
         </tr>
         
         <tr>
         <td>         
         <input type="radio" name="fee" value="monthly" />
         monthly      
         &nbsp;&nbsp;   
         <input type="radio" name="fee" value="annual" />
         annual
         &nbsp;&nbsp;
         fee
         </td>
         <td>
         <input type="text" name="site_fee" />
         </td>
         </tr>
         
         <tr>
         <td>Processor</td>
         <td>
         <select name="processor_id">
         <% while processors.EOF = false %>
         <option value="<%= processors("id") %>"><%= processors("name") %></option>
         <% 
            processors.MoveNext
            wend 
         %>
         </select>
         </td>
         </tr>
         
         <tr>
         <td>Site Creation Date</td>
         <td>
         <input type="text" size="2" name="site_creation_day" value="<%= day(date) %>" />
         &nbsp;
         <select name="site_creation_month">
         <option value="1" <% if month(date) = "1" then %>selected<% end if %>>January</option>
         <option value="2" <% if month(date) = "2" then %>selected<% end if %>>February</option>
         <option value="3" <% if month(date) = "3" then %>selected<% end if %>>March</option>
         <option value="4" <% if month(date) = "4" then %>selected<% end if %>>April</option>
         <option value="5" <% if month(date) = "5" then %>selected<% end if %>>May</option>
         <option value="6" <% if month(date) = "6" then %>selected<% end if %>>June</option>
         <option value="7" <% if month(date) = "7" then %>selected<% end if %>>July</option>
         <option value="8" <% if month(date) = "8" then %>selected<% end if %>>August</option>
         <option value="9" <% if month(date) = "9" then %>selected<% end if %>>September</option>
         <option value="10" <% if month(date) = "10" then %>selected<% end if %>>October</option>
         <option value="11" <% if month(date) = "11" then %>selected<% end if %>>November</option>
         <option value="12" <% if month(date) = "12" then %>selected<% end if %>>December</option>
         </select>
         &nbsp;
         <input type="text" size="4" name="site_creation_year" value="<%= year(date) %>" />
         </td>
         </tr>
         </table>
     </td>
     </tr>
     </table>
</td>
</tr>

<tr>
<td>
    <table width="100%" cellpadding="5">
    <tr>
    <td>
    <input type="button" value="add site" 
            onclick="SelectValue('client_id', '0');
                     SelectClient('0');
                     document.whcm.site_id.value = '0';
                     document.whcm.site_name.value = '';                     
                     document.whcm.site_user.value = '';                     
                     document.whcm.site_fee.value = '';
                     document.location.hash = '#edit';"/>
    </td>
    
    <td align="right">
    <input type="button" value="save"
           onclick="document.whcm.save.value = '0';
                    document.whcm.submit();" />
    &nbsp;
    <input type="button" value="cancel"
           onclick="document.whcm.reset();" />
    &nbsp;
    <input type="button" value="log out" 
           onclick="document.cookie = 'db_user=';
                    document.cookie = 'db_pass=';
                    document.whcm.submit();" />
    </td>
    </tr>
    </table>
</td>
</tr>

<tr>
<td>
     <table width="100%" cellpadding="5" bgcolor="eecc99">
     <tr>
     <td></td>
     <td class="headings" valign="top">Client Name & <br /> Contact Info</td>
     <td class="headings" valign="top">Domain & User</td>
     <td class="headings" valign="top">Name Vendor</td>
     <td class="headings" valign="top">Monthly <br /> Payment</td>
     <td class="headings" valign="top">Annual <br /> Payment</td>
     <td class="headings" valign="top">Payment <br /> Method</td>
     <td class="headings" valign="top">Account Creation <br /> Date</td>
     </tr>
     <%
     client_id = ""

     while client_sites.EOF = false
     %>

     <tr>
     <td>
     <% if client_id <> client_sites("client_id") then %>
     <input type="button" value="add site" 
            onclick="SelectValue('client_id', '<%= client_sites("client_id") %>');
                     SelectClient('<%= client_sites("client_id") %>');
                     document.whcm.site_id.value = '0';
                     document.whcm.site_name.value = '';                     
                     document.whcm.site_user.value = '';                     
                     document.whcm.site_fee.value = '';
                     document.location.hash = '#edit';"/>
     <% end if %>
     </td>

     <td>
     <% if client_id <> client_sites("client_id") then %>
     <a href="mailto:<%= client_sites("email") %>">
     <%= client_sites("client_name") %></a>
     <% end if %>
     </td>

     <td>
     <a href="http://<%= client_sites("site_name") %>">
     <%= client_sites("site_name") %></a>
     </td>

     <td>
     <%= client_sites("name_vendor_name") %>
     </td>

     <td>
     <% if client_sites("monthly_fee") <> 0.00 then %>
     <%= client_sites("monthly_fee") %>
     <% end if %>
     </td>

     <td>
     <% if client_sites("annual_fee") <> 0.00 then %>
     <%= client_sites("annual_fee") %>
     <% end if %>
     </td>

     <td>
     <%= client_sites("processor_name") %>
     </td>

     <td>
     <%= client_sites("creation_date") %>
     </td>

     <td>
     <input type="button" value="edit" 
            onclick="SelectValue('client_id', '<%= client_sites("client_id") %>');
                     SelectClient('<%= client_sites("client_id") %>');
                     document.whcm.site_id.value = '<%= client_sites("site_id") %>';
                     document.whcm.site_name.value = '<%= client_sites("site_name") %>';
                     SelectValue('name_vendor_id', '<%= client_sites("name_vendor_id") %>');
                     document.whcm.site_user.value = '<%= client_sites("user") %>';
                     <% if client_sites("annual_fee") <> 0 then %>
                     document.whcm.site_fee.value = '<%= client_sites("annual_fee") %>';
                     document.whcm.fee[1].checked = true;
                     <% else %>
                     document.whcm.site_fee.value = '<%= client_sites("monthly_fee") %>';
                     document.whcm.fee[0].checked = true;
                     <% end if %>
                     SelectValue('processor_id', '<%= client_sites("processor_id") %>');
                     document.whcm.site_creation_day.value = '<%= client_sites("creation_day") %>';
                     SelectValue('site_creation_month', '<%= client_sites("creation_month") %>');
                     document.whcm.site_creation_year.value = '<%= client_sites("creation_year") %>';
                     document.location.hash = '#edit';" />
     </td>
     
     <td>
     <input type="button" value="delete" 
            onclick="document.whcm.site_id.value = '-<%= client_sites("site_id") %>';
                     document.whcm.submit();" />
     </td>
     </tr>

     <tr>
     <td>
     </td>

     <td>
     <% if client_id <> client_sites("client_id") then %>
     <%= client_sites("phone_number") %>
     <%
     client_id = client_sites("client_id")
     end if
     %>
     </td>

     <td>
     <%= client_sites("user") %>
     </td>
     
     <td align="right" colspan="7"><input type="text" name="deleted_domain_<%= client_sites("site_id") %>" /></td>
     </tr>
     <% 
        client_sites.MoveNext
        wend 
     %>
     
     <tr>
     <td colspan="2">
     <select name="month" 
             onchange="document.whcm.save.value = '';
                       document.whcm.submit();">
     <option value="0">All Sites</option>
     <option value="1" <% if selected_month = "1" then %>selected<% end if %>>January</option>
     <option value="2" <% if selected_month = "2" then %>selected<% end if %>>February</option>
     <option value="3" <% if selected_month = "3" then %>selected<% end if %>>March</option>
     <option value="4" <% if selected_month = "4" then %>selected<% end if %>>April</option>
     <option value="5" <% if selected_month = "5" then %>selected<% end if %>>May</option>
     <option value="6" <% if selected_month = "6" then %>selected<% end if %>>June</option>
     <option value="7" <% if selected_month = "7" then %>selected<% end if %>>July</option>
     <option value="8" <% if selected_month = "8" then %>selected<% end if %>>August</option>
     <option value="9" <% if selected_month = "9" then %>selected<% end if %>>September</option>
     <option value="10" <% if selected_month = "10" then %>selected<% end if %>>October</option>
     <option value="11" <% if selected_month = "11" then %>selected<% end if %>>November</option>
     <option value="12" <% if selected_month = "12" then %>selected<% end if %>>December</option>
     </select>
     </td>
     
     <td colspan="2"></td>
     
     <td class="headings"><%= monthly_fee("sum") %></td>
     
     <td class="headings"><%= annual_fee("sum") %></td>          
     
     <td class="headings" colspan="4" align="right"><%= bcadd(monthly_fee("sum"), annual_fee("sum"), 2) %></td>
     </tr>
     </table>
</td>
</tr>

<tr>
<td>
    <table width="100%" cellpadding="5">
    <tr>
    <td>
    <input type="button" value="add site" 
            onclick="SelectValue('client_id', '0');
                     SelectClient('0');
                     document.whcm.site_id.value = '0';
                     document.whcm.site_name.value = '';                     
                     document.whcm.site_user.value = '';                     
                     document.whcm.site_fee.value = '';
                     document.location.hash = '#edit';"/>
    </td>
    
    <td align="right">
    <input type="button" value="save"
           onclick="document.whcm.save.value = '0';
                    document.whcm.submit();" />
    &nbsp;
    <input type="button" value="cancel"
           onclick="document.whcm.reset();" />
    &nbsp;
    <input type="button" value="log out" 
           onclick="document.cookie = 'db_user=';
                    document.cookie = 'db_pass=';
                    document.whcm.submit();" />
    </td>
    </tr>
    </table>
</td>
</tr>

<% end if 'If logged_in = true %>

<% if logged_in = false then %>

<tr>
<td>User Name </td>
<td><input type="text" name="db_user" /></td>
</tr>

<tr>
<td>Password</td>
<td><input type="password" name="db_pass" /></td>
</tr>

<tr>
<td colspan="2" align="right">
<input type="button" value="log in"
       onclick="document.cookie = 'db_user=' + document.whcm.db_user.value;
                document.cookie = 'db_pass=' + document.whcm.db_pass.value;
                document.whcm.submit();">
</td>
</tr>

<% end if 'If logged_in = false %>

</table>
</form>
</body>
</html>
